> For clean Markdown of any page, append .md to the page URL. > For a complete documentation index, see https://reference.flatfile.com/api-reference/actions/bulk-create/llms.txt. > For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://reference.flatfile.com/_mcp/server. # Create several actions POST https://api.x.flatfile.com/v1/actions/bulk Content-Type: application/json Reference: https://reference.flatfile.com/api-reference/actions/bulk-create ## Authentication - `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer `, where token is your auth token. ## Request ### Query parameters - `spaceId` (string, required) — The Space ID for which to create the Actions. ### Body (application/json) This endpoint expects a list of APIActionConfig. - `list of APIActionConfig` ## Response ### 200 - `data` (list of APIAction, required) ## Types ### APIActionConfig - `label` (string, required) — The text on the Button itself - `targetId` (string, required) - `confirm` (boolean, optional) — Whether to show a modal to confirm the action - `constraints` (list of ActionConstraint, optional) — A limitation or restriction on the action. - `createdFrom` (string, optional) — The action that this action was cloned from - `deletedAt` (datetime, optional) — The time this action was deleted - `description` (string, optional) — The text that appears in the dialog after the action is clicked. - `guardrail` (Guardrail, optional) - `guide` (Guide, optional) - `icon` (string, optional) — Icon will work on primary actions. It will only accept an already existing Flatfile design system icon. - `inputForm` (InputForm, optional) — Adds an input form for this action after it is clicked. - `invalidConditionalMessaging` (boolean, optional) — When enabled, shows dynamic confirmation messages based on record validation status instead of the static description - `invalidRecordsMessage` (string, optional) — Custom message to show when there are invalid records (only used when invalidConditionalMessaging is true) - `lastPropagatedAt` (datetime, optional) — The last time this action was propagated to a workbook - `messages` (list of ActionMessage, optional) - `mode` (enum, optional) — Foreground and toolbarBlocking action mode will prevent interacting with the resource until complete - Allowed values: `foreground`, `background`, `toolbarBlocking` - `mount` (ActionMount, optional) - `operation` (string, optional) — This will become the job operation that is triggered - `primary` (boolean, optional) — A primary action will be more visibly present, whether in Sheet or Workbook. - `schedule` (enum, optional) — Determines if the action should happen on a regular cadence. - Allowed values: `weekly`, `daily`, `hourly` - `tooltip` (string, optional) — A tooltip that appears when hovering the action button - `type` (string, optional) — **This is deprecated.** - `validRecordsMessage` (string, optional) — Custom message to show when all records are valid (only used when invalidConditionalMessaging is true) - `requireAllValid` (boolean, optional, deprecated) — **This is deprecated. Use `constraints` instead.** - `requireSelection` (boolean, optional, deprecated) — **This is deprecated. Use `constraints` instead.** - `slug` (string, optional, deprecated) — **This is deprecated. Use `operation` instead.** ### APIAction - `createdAt` (datetime, required) - `id` (string, required) — Action ID - `label` (string, required) — The text on the Button itself - `targetId` (string, required) - `updatedAt` (datetime, required) - `confirm` (boolean, optional) — Whether to show a modal to confirm the action - `constraints` (list of ActionConstraint, optional) — A limitation or restriction on the action. - `createdFrom` (string, optional) — The action that this action was cloned from - `deletedAt` (datetime, optional) — The time this action was deleted - `description` (string, optional) — The text that appears in the dialog after the action is clicked. - `guardrail` (Guardrail, optional) - `guide` (Guide, optional) - `icon` (string, optional) — Icon will work on primary actions. It will only accept an already existing Flatfile design system icon. - `inputForm` (InputForm, optional) — Adds an input form for this action after it is clicked. - `invalidConditionalMessaging` (boolean, optional) — When enabled, shows dynamic confirmation messages based on record validation status instead of the static description - `invalidRecordsMessage` (string, optional) — Custom message to show when there are invalid records (only used when invalidConditionalMessaging is true) - `lastPropagatedAt` (datetime, optional) — The last time this action was propagated to a workbook - `messages` (list of ActionMessage, optional) - `mode` (enum, optional) — Foreground and toolbarBlocking action mode will prevent interacting with the resource until complete - Allowed values: `foreground`, `background`, `toolbarBlocking` - `mount` (ActionMount, optional) - `operation` (string, optional) — This will become the job operation that is triggered - `primary` (boolean, optional) — A primary action will be more visibly present, whether in Sheet or Workbook. - `schedule` (enum, optional) — Determines if the action should happen on a regular cadence. - Allowed values: `weekly`, `daily`, `hourly` - `tooltip` (string, optional) — A tooltip that appears when hovering the action button - `type` (string, optional) — **This is deprecated.** - `validRecordsMessage` (string, optional) — Custom message to show when all records are valid (only used when invalidConditionalMessaging is true) - `requireAllValid` (boolean, optional, deprecated) — **This is deprecated. Use `constraints` instead.** - `requireSelection` (boolean, optional, deprecated) — **This is deprecated. Use `constraints` instead.** - `slug` (string, optional, deprecated) — **This is deprecated. Use `operation` instead.** ### ActionConstraint - `type`: `hasAllValid` - `ignoreSelection` (boolean, optional) - `type`: `hasSelection` - `type`: `hasData` - `type`: `hasColumnEnabled` ### Guardrail - `content` (string, required) — Markdown guardrail for this action ### Guide - `content` (string, required) — Markdown guidance for this action ### InputForm - `type` (enum, required) - Allowed values: `simple` - `fields` (list of InputField, required) ### ActionMessage - `type` (enum, required) - Allowed values: `error`, `info` - `content` (string, required) ### ActionMount - `type`: `sheet` - `slugs` (list of string, optional) - `type`: `workbook` - `slugs` (list of string, optional) - `type`: `field` - `keys` (list of string, optional) - `type`: `document` - `type`: `file` ### InputField - `key` (string, required) — Unique key for a Field. - `label` (string, required) — Visible name of a Field. - `type` (string, required) — Field Types inform the user interface how to sort and display data. - `description` (string, optional) — Brief description below the name of the Field. - `defaultValue` (any, optional) — Default value for a Field. - `config` (InputConfig, optional) — Additional configuration for enum Fields. - `constraints` (list of InputConstraint, optional) — Indicate additional validations that will be applied to the Field. ### InputConfig - `options` (list of InputEnumPropertyOption, required) ### InputConstraint - `type` (enum, required) - Allowed values: `required` ### InputEnumPropertyOption - `value` (any, required) — The value or ID of this option. This value will be sent in egress. The type is a string | integer | boolean. - `label` (string, optional) — A visual label for this option, defaults to value if not provided - `description` (string, optional) — A short description for this option - `color` (string, optional) — An optional color to assign this option - `icon` (string, optional) — A reference pointer to a previously registered icon - `meta` (map from string to any, optional) — An arbitrary JSON object to be associated with this option and made available to hooks ## Examples **Request** ```json [ { "label": "label", "targetId": "targetId" }, { "label": "label", "targetId": "targetId" } ] ``` **Response** ```json { "data": [ { "createdAt": "2024-01-15T09:30:00Z", "id": "id", "label": "label", "targetId": "targetId", "updatedAt": "2024-01-15T09:30:00Z", "confirm": true, "constraints": [ { "type": "hasAllValid", "ignoreSelection": true }, { "type": "hasAllValid", "ignoreSelection": true } ], "createdFrom": "createdFrom", "deletedAt": "2024-01-15T09:30:00Z", "description": "description", "guardrail": { "content": "content" }, "guide": { "content": "content" }, "icon": "icon", "inputForm": { "type": "simple", "fields": [ { "key": "key", "label": "label", "type": "type", "description": "description", "defaultValue": { "key": "value" }, "constraints": [] }, { "key": "key", "label": "label", "type": "type", "description": "description", "defaultValue": { "key": "value" }, "constraints": [] } ] }, "invalidConditionalMessaging": true, "invalidRecordsMessage": "invalidRecordsMessage", "lastPropagatedAt": "2024-01-15T09:30:00Z", "messages": [ { "type": "error", "content": "content" }, { "type": "error", "content": "content" } ], "mode": "foreground", "mount": { "type": "sheet", "slugs": [ "slugs", "slugs" ] }, "operation": "operation", "primary": true, "schedule": "weekly", "tooltip": "tooltip", "type": "type", "validRecordsMessage": "validRecordsMessage", "requireAllValid": true, "requireSelection": true, "slug": "slug" }, { "createdAt": "2024-01-15T09:30:00Z", "id": "id", "label": "label", "targetId": "targetId", "updatedAt": "2024-01-15T09:30:00Z", "confirm": true, "constraints": [ { "type": "hasAllValid", "ignoreSelection": true }, { "type": "hasAllValid", "ignoreSelection": true } ], "createdFrom": "createdFrom", "deletedAt": "2024-01-15T09:30:00Z", "description": "description", "guardrail": { "content": "content" }, "guide": { "content": "content" }, "icon": "icon", "inputForm": { "type": "simple", "fields": [ { "key": "key", "label": "label", "type": "type", "description": "description", "defaultValue": { "key": "value" }, "constraints": [] }, { "key": "key", "label": "label", "type": "type", "description": "description", "defaultValue": { "key": "value" }, "constraints": [] } ] }, "invalidConditionalMessaging": true, "invalidRecordsMessage": "invalidRecordsMessage", "lastPropagatedAt": "2024-01-15T09:30:00Z", "messages": [ { "type": "error", "content": "content" }, { "type": "error", "content": "content" } ], "mode": "foreground", "mount": { "type": "sheet", "slugs": [ "slugs", "slugs" ] }, "operation": "operation", "primary": true, "schedule": "weekly", "tooltip": "tooltip", "type": "type", "validRecordsMessage": "validRecordsMessage", "requireAllValid": true, "requireSelection": true, "slug": "slug" } ] } ``` **SDK Code** ```python import requests url = "https://api.x.flatfile.com/v1/actions/bulk" querystring = {"spaceId":"spaceId"} payload = [ { "label": "label", "targetId": "targetId" }, { "label": "label", "targetId": "targetId" } ] headers = { "X-Disable-Hooks": "true", "Authorization": "Bearer ", "Content-Type": "application/json" } response = requests.post(url, json=payload, headers=headers, params=querystring) print(response.json()) ``` ```typescript import { FlatfileClient } from "@flatfile/api"; const client = new FlatfileClient({ token: "YOUR_TOKEN" }); await client.actions.bulkCreate({ spaceId: "spaceId", body: [{ label: "label", targetId: "targetId" }, { label: "label", targetId: "targetId" }] }); ``` ```go package main import ( "fmt" "strings" "net/http" "io" ) func main() { url := "https://api.x.flatfile.com/v1/actions/bulk?spaceId=spaceId" payload := strings.NewReader("[\n {\n \"label\": \"label\",\n \"targetId\": \"targetId\"\n },\n {\n \"label\": \"label\",\n \"targetId\": \"targetId\"\n }\n]") req, _ := http.NewRequest("POST", url, payload) req.Header.Add("X-Disable-Hooks", "true") req.Header.Add("Authorization", "Bearer ") req.Header.Add("Content-Type", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby require 'uri' require 'net/http' url = URI("https://api.x.flatfile.com/v1/actions/bulk?spaceId=spaceId") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Post.new(url) request["X-Disable-Hooks"] = 'true' request["Authorization"] = 'Bearer ' request["Content-Type"] = 'application/json' request.body = "[\n {\n \"label\": \"label\",\n \"targetId\": \"targetId\"\n },\n {\n \"label\": \"label\",\n \"targetId\": \"targetId\"\n }\n]" response = http.request(request) puts response.read_body ``` ```java import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.post("https://api.x.flatfile.com/v1/actions/bulk?spaceId=spaceId") .header("X-Disable-Hooks", "true") .header("Authorization", "Bearer ") .header("Content-Type", "application/json") .body("[\n {\n \"label\": \"label\",\n \"targetId\": \"targetId\"\n },\n {\n \"label\": \"label\",\n \"targetId\": \"targetId\"\n }\n]") .asString(); ``` ```php request('POST', 'https://api.x.flatfile.com/v1/actions/bulk?spaceId=spaceId', [ 'body' => '[ { "label": "label", "targetId": "targetId" }, { "label": "label", "targetId": "targetId" } ]', 'headers' => [ 'Authorization' => 'Bearer ', 'Content-Type' => 'application/json', 'X-Disable-Hooks' => 'true', ], ]); echo $response->getBody(); ``` ```csharp using RestSharp; var client = new RestClient("https://api.x.flatfile.com/v1/actions/bulk?spaceId=spaceId"); var request = new RestRequest(Method.POST); request.AddHeader("X-Disable-Hooks", "true"); request.AddHeader("Authorization", "Bearer "); request.AddHeader("Content-Type", "application/json"); request.AddParameter("application/json", "[\n {\n \"label\": \"label\",\n \"targetId\": \"targetId\"\n },\n {\n \"label\": \"label\",\n \"targetId\": \"targetId\"\n }\n]", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ``` ```swift import Foundation let headers = [ "X-Disable-Hooks": "true", "Authorization": "Bearer ", "Content-Type": "application/json" ] let parameters = [ [ "label": "label", "targetId": "targetId" ], [ "label": "label", "targetId": "targetId" ] ] as [String : Any] let postData = JSONSerialization.data(withJSONObject: parameters, options: []) let request = NSMutableURLRequest(url: NSURL(string: "https://api.x.flatfile.com/v1/actions/bulk?spaceId=spaceId")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "POST" request.allHTTPHeaderFields = headers request.httpBody = postData as Data let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ```